Index: trunk/source/processes/hadronic/models/de_excitation/History
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/History	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/History	(revision 1315)
@@ -14,4 +14,141 @@
      * Please list in reverse chronological order (last date on top)
      ---------------------------------------------------------------
+
+9 June 2010 Vladimir Ivanchenko (hadr-deex-V09-03-18)
+----------------------------------------------------------
+- G4Evaporation - fixed problem of isotope production for high Z
+                  fragments introduced in previous tags
+
+25 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-17)
+----------------------------------------------------------
+- G4E1Probability - added numerical protection to avoid division by zero
+
+19 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-16)
+----------------------------------------------------------
+- G4UnstableFragmentBreakUp - fix selection of decay channel by addition of check 
+                              on residual fragment Z and A (addressed
+                              problem reported stt for the tag 03-14)
+
+19 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-15)
+----------------------------------------------------------
+- G4UnstableFragmentBreakUp - fixed selection of decay channel
+- G4E1Probability - code cleanup and optimisation by usage of G4Pow, integer A 
+                    and introduction of const members
+- G4GEMProbability - code cleanup and optimisation by usage of G4Pow and integer Z,A
+- G4ExcitationHandler - forced  FermiBreakUp for A < 5
+- G4PhotonEvaporation - (F.Lei) added correction of electron state after emission
+- G4FermiFragmentsPool - JMQ fixed fragment 111
+
+11 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-14)
+----------------------------------------------------------
+- G4UnstableFragmentBreakUp - new class to decay exotic fragmnet (like 2n or 2p)
+- G4Evaporation - added call to G4UnstableFragmentBreakUp if natural abandances
+                  of cold fragment is zero; optimized logic of stopping of 
+                  evaporation loop
+- G4PhotonEvaporation - cleanup new methods EmittedFragment and BreakUpFragment
+- G4ExcitationHandler - use BreakUpFragment method for photon deexcitation
+
+10 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-13)
+----------------------------------------------------------
+- G4VGammaDeexcitation - take into account bounding energy of electron 
+                         in the case of electron emmision; fixed kinematic
+- G4DiscreteGammaTransition - Removed unphysical corretions of gamma energy; 
+                         fixed default particle as gamma; do not subtract 
+                         bounding energy in case of electron emmision
+- G4ExcitationHandler - allowed emmision e- instead of gamma due to internal conversion
+
+
+03 May 2010 Vladimir Ivanchenko (hadr-deex-V09-03-12)
+----------------------------------------------------------
+- G4Evaporation - improved condition how to stop deexcitation loop
+- G4VGammaDeexcitation - take into account electron mass in the case of
+                         electron emmision
+- G4PhotonEvaporation - improved printout
+- G4ExcitationHandler - disable MFM
+- G4StatMFFragment, G4CompetitiveFission, G4EvaporationProbability,
+  G4GEMProbability - use correct header files
+
+28 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-11)
+----------------------------------------------------------
+- G4ExcitationHandler - (JQM+VI) add check on stability of primary;
+                                 do evaporation if FermiBreakUp or MFM
+                                 cannot deexcite a fragment; 
+	                         added SetParameters method
+- G4Evaporation - rewrite BreakUp method; added Initialise method, where setup
+                  all options and not at run time; added InitialiseEvaporation
+                  method to setup decay channels; changed order of decay
+                  channels - first photon evaporation, second - fision,
+                  after all other channels as before
+- virtual interfaces - moved constructors and destructors to source files
+
+26 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-10)
+----------------------------------------------------------
+- G4FermiConfiguration - (JQM) parameter of Coulomb energy Kappa is changed 
+                          from 1 to 6 according to recommendation of original
+                          author of the model A. Botvina
+- G4FermiPhaseSpaceDecay - (JQM) improved model of sampling of kinetic energy;
+                         - (VI) cleanup the code by using G4Pow; moved constructor
+                            and destructor to the source 
+
+25 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-09)
+----------------------------------------------------------
+- G4ExcitationHandler - (JQM+VI) apply FermiBreakUp to fragments with A>1 
+                        (before was A>4) in order to reduce number of 
+                        fake gamma produced in order deexcite light
+                        fragments; added parameter minExcitation = 1 keV
+- G4VEvaporationChannel, G4PhotonEvaporation - added 2 new virtual methods 
+                        EmittedFragment and BreakUpFragment
+
+23 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-08)
+----------------------------------------------------------
+- G4VGammaDeexcitation - kinematic of 2-body decay rewritten
+- G4DiscreteGammaTransition, G4DiscreteGammaDeexcitation, 
+  G4ContinuumGammaDeexcitation - set energy tolerance 1 keV;
+                                 set destructors to be virtual
+
+21 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-07)
+----------------------------------------------------------
+- G4FermiFragmentsPool - (JMQ) extended list of stable fragments
+- G4DiscreteGammaTransition - (JMQ) make transition depended on Z and A
+                                    (before was only Z) and added 
+                                    energy tolerance
+- G4ContinuumGammaDeexcitation - (JQM) more accurate Lorentz computations
+- G4VGammaDeexcitation - (JMQ) improved Lorentz computations
+
+20 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-06)
+----------------------------------------------------------
+- G4GEMProbability - (JQM + VI) fixed numerical problem (division by zero)
+
+16 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-05)
+----------------------------------------------------------
+- G4ExcitationHandler - enable Multi-Fragmentation model
+- G4StatMFMacroTemperature - cleanup logic of solving equation for
+           temperature; moved constructors and destructor to source
+
+09 April 2010 Vladimir Ivanchenko (hadr-deex-V09-03-04)
+----------------------------------------------------------
+- G4ProtonEvaporationProbability, G4DeuteronEvaporationProbability,
+  G4TritonEvaporationProbability, G4He3EvaporationProbability,
+  G4AlphaEvaporationProbability - (JMQ) return back to published
+               variant OPT3 (Kalbach) parameterization of inverse 
+	       cross section 
+
+05 March 2010 Vladimir Ivanchenko (hadr-deex-V09-03-03)
+----------------------------------------------------------
+- G4Evaporation - set as a default variant evaporation combined 
+                  standard + GEM probabilities
+
+17 February 2009 Vladimir Ivanchenko (hadr-deex-V09-03-02)
+----------------------------------------------------------
+- G4ExcitationHandler - deactivate Multi-Fragmentation model
+
+05 February 2009 Vladimir Ivanchenko (hadr-deex-V09-03-01)
+----------------------------------------------------------
+- G4ExcitationHandler - activate FermiBreakUp and Multi-Fragmentation models
+
+18 January 2010  Vladimir Ivanchenko (hadr-deex-V09-03-00)
+----------------------------------------------------------
+- Move 9.3 version to the head of cvs for following files: G4FissionBarrier.hh,
+  G4FissionBarrier.cc, G4VGammaDeexcitation.cc, G4VGammaDeexcitation.hh,
 
 09 December 2009 Gunter Folger  (hadr-deex-V09-02-23)
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4Evaporation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4Evaporation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4Evaporation.hh	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Evaporation.hh,v 1.7 2009/07/27 10:32:05 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4Evaporation.hh,v 1.12 2010/05/11 11:34:09 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -32,6 +32,8 @@
 //
 //
-// Alex Howard - added protection for negative probabilities in the sum, 14/2/07
-// V.Ivanchenko - added Combined decay channels (default + GEM) 27/07/09
+// 14/02/2007 Alex Howard - added protection for negative probabilities in the sum 
+// 27/07/2009 V.Ivanchenko - added Combined decay channels (default + GEM) 
+// 11/05/2010 V.Ivanchenko - rewrited technical part do not "new" and "delete" 
+//                           of small objects
 
 #ifndef G4Evaporation_h
@@ -43,6 +45,8 @@
 #include "G4VEvaporationChannel.hh"
 #include "G4Fragment.hh"
+#include "G4UnstableFragmentBreakUp.hh"
 
 class G4VEvaporationFactory;
+class G4NistManager;
 
 //#define debug
@@ -52,11 +56,14 @@
 public:
   G4Evaporation();
-  G4Evaporation(std::vector<G4VEvaporationChannel*> * aChannelsVector) :
-    theChannels(aChannelsVector), theChannelFactory(0)
-  {};
+  G4Evaporation(std::vector<G4VEvaporationChannel*> * aChannelsVector);
 	 
   virtual ~G4Evaporation();
 
+  virtual void Initialise();
+
 private:
+
+  void InitialiseEvaporation();
+
   G4Evaporation(const G4Evaporation &right);
 
@@ -66,4 +73,5 @@
 
 public:
+
   G4FragmentVector * BreakItUp(const G4Fragment &theNucleus);
 
@@ -77,27 +85,12 @@
 #endif
 
-
   std::vector<G4VEvaporationChannel*> * theChannels;
+  std::vector<G4double>   probabilities;
   G4VEvaporationFactory * theChannelFactory;
-  
-  
-  class SumProbabilities : public std::binary_function<G4double,G4double,G4double>
-  {
-  public:
-    SumProbabilities() : total(0.0) {}
-    G4double operator() (G4double& /* probSoFar */, G4VEvaporationChannel*& frag)
-    { 
-      G4double temp_prob = frag->GetEmissionProbability();
-      if(temp_prob >= 0.0) total += temp_prob;
-      //      total += frag->GetEmissionProbability();
-      return total;
-    }
+  G4int nChannels;
+  G4double minExcitation;
+  G4NistManager* nist;
+  G4UnstableFragmentBreakUp unstableBreakUp;
     
-    G4double GetTotal() { return total; }
-  public:
-    G4double total;
-    
-  };
-
 };
 
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4EvaporationFactory.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4EvaporationFactory.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4EvaporationFactory.hh	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4EvaporationFactory.hh,v 1.3 2006/06/29 20:09:55 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4EvaporationFactory.hh,v 1.4 2010/04/27 11:43:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -41,9 +41,9 @@
 {
 public:
-  G4EvaporationFactory() {};
-  virtual ~G4EvaporationFactory() {};
+  G4EvaporationFactory();
+  virtual ~G4EvaporationFactory();
 
 private:
-  G4EvaporationFactory(const G4EvaporationFactory & ) : G4VEvaporationFactory() {};
+  G4EvaporationFactory(const G4EvaporationFactory & );
   const G4EvaporationFactory & operator=(const G4EvaporationFactory & val);
   G4bool operator==(const G4EvaporationFactory & val) const;
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4VEvaporation.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4VEvaporation.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/include/G4VEvaporation.hh	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4VEvaporation.hh,v 1.4 2008/09/19 13:32:54 ahoward Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4VEvaporation.hh,v 1.6 2010/04/27 14:00:40 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -46,6 +46,6 @@
 {
 public:
-  G4VEvaporation() {};
-  virtual ~G4VEvaporation() {}; // *
+  G4VEvaporation();
+  virtual ~G4VEvaporation(); 
 
 private:  
@@ -57,5 +57,8 @@
   
 public:
+
   virtual G4FragmentVector * BreakItUp(const G4Fragment &theNucleus) = 0;
+
+  virtual void Initialise();
 
   // for inverse cross section choice
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4AlphaEvaporationProbability.cc	(revision 1315)
@@ -225,5 +225,8 @@
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-  if (cut < 0.) ecut2 = ecut - 2.;
+//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
+//  if (cut < 0.) ecut2 = ecut - 2.;
+  if (cut < 0.) ecut2 = ecut;
   elab = K * FragmentA / ResidualA;
   sig = 0.;
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4DeuteronEvaporationProbability.cc	(revision 1315)
@@ -206,6 +206,7 @@
         
   //JMQ 13/02/09 increase of reduced radius to lower the barrier
-  // ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
-  ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
+  //  ec = 1.44 * theZ * ResidualZ / (1.5*ResidualAthrd+ra);
+   ec = 1.44 * theZ * ResidualZ / (1.7*ResidualAthrd+ra);
+
   ecsq = ec * ec;
   p = p0 + p1/ec + p2/ecsq;
@@ -225,5 +226,8 @@
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-  if (cut < 0.) ecut2 = ecut - 2.;
+//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
+//  if (cut < 0.) ecut2 = ecut - 2.;
+  if (cut < 0.) ecut2 = ecut;
   elab = K * FragmentA / ResidualA;
   sig = 0.;
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4Evaporation.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4Evaporation.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4Evaporation.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4Evaporation.cc,v 1.15 2009/09/16 15:32:25 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4Evaporation.cc,v 1.25 2010/06/09 11:56:47 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -38,5 +38,10 @@
 // superimposed Coulomb barrier (if useSICBis set true, by default is false) 
 //
-// V.Ivanchenko added G4EvaporationDefaultGEMFactory option, 27/07/09
+// V.Ivanchenko (27 July 2009) added G4EvaporationDefaultGEMFactory option
+// V.Ivanchenko (10 May 2010) rewrited BreakItUp method: do not make new/delete
+//                            photon channel first, fission second,
+//                            added G4UnstableFragmentBreakUp to decay 
+//                            unphysical fragments (like 2n or 2p),
+//                            use Z and A integer
 
 #include "G4Evaporation.hh"
@@ -45,17 +50,46 @@
 #include "G4EvaporationDefaultGEMFactory.hh"
 #include "G4HadronicException.hh"
-#include <numeric>
+#include "G4NistManager.hh"
 
 G4Evaporation::G4Evaporation() 
 {
-  theChannelFactory = new G4EvaporationFactory();
-  //theChannelFactory = new G4EvaporationDefaultGEMFactory();
-  theChannels = theChannelFactory->GetChannel();
+  //theChannelFactory = new G4EvaporationFactory();
+  theChannelFactory = new G4EvaporationDefaultGEMFactory();
+  InitialiseEvaporation();
+}
+
+G4Evaporation::G4Evaporation(std::vector<G4VEvaporationChannel*> * aChannelsVector) 
+  : theChannels(aChannelsVector), theChannelFactory(0), nChannels(0)
+{
+  InitialiseEvaporation();
 }
 
 G4Evaporation::~G4Evaporation()
 {
-  if (theChannels != 0) theChannels = 0;
-  if (theChannelFactory != 0) delete theChannelFactory;
+  if (theChannels != 0) { theChannels = 0; }
+  if (theChannelFactory != 0) { delete theChannelFactory; }
+}
+
+void G4Evaporation::InitialiseEvaporation()
+{
+  nist = G4NistManager::Instance();
+  minExcitation = CLHEP::keV;
+  if(theChannelFactory) { theChannels = theChannelFactory->GetChannel(); }
+  nChannels = theChannels->size();
+  probabilities.resize(nChannels, 0.0);
+  Initialise();
+}
+
+void G4Evaporation::Initialise()
+{
+  // loop over evaporation channels
+  std::vector<G4VEvaporationChannel*>::iterator i;
+  for (i=theChannels->begin(); i != theChannels->end(); ++i) 
+    {
+      // for inverse cross section choice
+      (*i)->SetOPTxs(OPTxs);
+      // for superimposed Coulomb Barrier for inverse cross sections
+      (*i)->UseSICB(useSICB);
+    }
 }
 
@@ -64,5 +98,5 @@
   if (theChannelFactory != 0) delete theChannelFactory;
   theChannelFactory = new G4EvaporationFactory();
-  theChannels = theChannelFactory->GetChannel();
+  InitialiseEvaporation();
 }
 
@@ -71,5 +105,5 @@
   if (theChannelFactory != 0) delete theChannelFactory;
   theChannelFactory = new G4EvaporationGEMFactory();
-  theChannels = theChannelFactory->GetChannel();
+  InitialiseEvaporation();
 }
 
@@ -78,11 +112,176 @@
   if (theChannelFactory != 0) delete theChannelFactory;
   theChannelFactory = new G4EvaporationDefaultGEMFactory();
-  theChannels = theChannelFactory->GetChannel();
-}
-
+  InitialiseEvaporation();
+}
 
 G4FragmentVector * G4Evaporation::BreakItUp(const G4Fragment &theNucleus)
 {
-    G4FragmentVector * theResult = new G4FragmentVector;
+  G4FragmentVector * theResult = new G4FragmentVector;
+  G4FragmentVector * theTempResult;
+
+  // The residual nucleus (after evaporation of each fragment)
+  G4Fragment* theResidualNucleus = new G4Fragment(theNucleus);
+
+  G4double totprob, prob, oldprob = 0.0;
+  G4int maxchannel, i;
+
+  G4int Amax = theResidualNucleus->GetA_asInt();
+
+  // Starts loop over evaporated particles, loop is limited by number
+  // of nucleons
+  for(G4int ia=0; ia<Amax; ++ia) {
+ 
+    // g,n,p - evaporation is finished
+    G4int A = theResidualNucleus->GetA_asInt();
+    if(1 >= A) {
+      theResult->push_back(theResidualNucleus);
+      return theResult;
+    }
+
+    // check if it is stable, then finish evaporation
+    G4int Z = theResidualNucleus->GetZ_asInt();
+    G4double abun = nist->GetIsotopeAbundance(Z, A); 
+    /*
+    G4cout << "### G4Evaporation::BreakItUp step " << ia << " Z= " << Z
+	   << " A= " << A << " Eex(MeV)= " 
+	   << theResidualNucleus->GetExcitationEnergy()
+	   << " aban= " << abun << G4endl;
+    */
+    if(theResidualNucleus->GetExcitationEnergy() <= minExcitation && 
+       (abun > 0.0)) 
+      {
+	theResult->push_back(theResidualNucleus);
+	return theResult;
+      }
+
+    totprob = 0.0;
+    maxchannel = nChannels;
+
+    //G4cout << "### Evaporation loop #" << ia 
+    //	   << "  Fragment: " << theResidualNucleus << G4endl;
+
+    // loop over evaporation channels
+    for(i=0; i<nChannels; ++i) {
+      (*theChannels)[i]->Initialize(*theResidualNucleus);
+      prob = (*theChannels)[i]->GetEmissionProbability();
+      //G4cout << "  Channel# " << i << "  prob= " << prob << G4endl; 
+
+      //if(0 == i && 0.0 == abun) { prob = 0.0; }
+
+      totprob += prob;
+      probabilities[i] = totprob;
+      // if two recent probabilities are near zero stop computations
+      if(i>=8) {
+	if(prob <= totprob*1.e-8 && oldprob <= totprob*1.e-8) {
+	  maxchannel = i+1; 
+	  break;
+	}
+      }
+      oldprob = prob;
+    }
+
+    // photon evaporation in the case of no other channels available
+    // do evaporation chain and reset total probability
+    if(0.0 < totprob && probabilities[0] == totprob) {
+      theTempResult = (*theChannels)[0]->BreakUpFragment(theResidualNucleus);
+      if(theTempResult) {
+	size_t nsec = theTempResult->size();
+	for(size_t j=0; j<nsec; ++j) {
+	  theResult->push_back((*theTempResult)[j]);
+	}
+        delete theTempResult;
+      }
+      totprob = 0.0;
+    }
+
+    // stable fragnent - evaporation is finished
+    if(0.0 == totprob) {
+
+      // if fragment is exotic, then try to decay it
+      if(0.0 == abun && Z < 20) {
+        //G4cout << "$$$ Decay exotic fragment" << G4endl;
+	theTempResult = unstableBreakUp.BreakUpFragment(theResidualNucleus);
+	if(theTempResult) {
+	  size_t nsec = theTempResult->size();
+	  for(size_t j=0; j<nsec; ++j) {
+	    theResult->push_back((*theTempResult)[j]);
+	  }
+	  delete theTempResult;
+	}
+      }
+
+      // save residual fragment
+      theResult->push_back(theResidualNucleus);
+      return theResult;
+    }
+
+
+    // select channel
+    totprob *= G4UniformRand();
+    // loop over evaporation channels
+    for(i=0; i<maxchannel; ++i) { if(probabilities[i] >= totprob) { break; } }
+
+    // this should not happen
+    if(i >= nChannels) { i = nChannels - 1; }
+
+
+    // single photon evaporation, primary pointer is kept
+    if(0 == i) {
+      G4Fragment* gamma = (*theChannels)[0]->EmittedFragment(theResidualNucleus);
+      if(gamma) { theResult->push_back(gamma); }
+
+      // fission, return results to the main loop if fission is succesful
+    } else if(1 == i) {
+      theTempResult = (*theChannels)[1]->BreakUp(*theResidualNucleus);
+      if(theTempResult) {
+	size_t nsec = theTempResult->size();
+        G4bool deletePrimary = true;
+	for(size_t j=0; j<nsec; ++j) {
+          if(theResidualNucleus == (*theTempResult)[j]) { deletePrimary = false; }
+	  theResult->push_back((*theTempResult)[j]);
+	}
+        if(deletePrimary) { delete theResidualNucleus; }
+        delete theTempResult;
+	return theResult;
+      }
+
+      // other channels
+    } else {
+      theTempResult = (*theChannels)[i]->BreakUp(*theResidualNucleus);
+      if(theTempResult) {
+	size_t nsec = theTempResult->size();
+        if(nsec > 0) {
+          --nsec;
+	  for(size_t j=0; j<nsec; ++j) {
+	    theResult->push_back((*theTempResult)[j]);
+	  }
+	  // if the residual change its pointer 
+	  // then delete previous residual fragment and update to the new
+          if(theResidualNucleus != (*theTempResult)[nsec] ) { 
+	    delete theResidualNucleus; 
+	    theResidualNucleus = (*theTempResult)[nsec];
+	  }
+	}
+        delete theTempResult;
+      }
+    }
+  }
+
+  // loop is stopped, save residual
+  theResult->push_back(theResidualNucleus);
+  
+#ifdef debug
+  G4cout << "======== Evaporation Conservation Test ===========\n"
+	 << "==================================================\n";
+  CheckConservation(theNucleus,theResult);
+  G4cout << "==================================================\n";
+#endif
+  return theResult;
+}
+
+/*
+G4FragmentVector * G4Evaporation::BreakItUp(const G4Fragment &theNucleus)
+{
+  G4FragmentVector * theResult = new G4FragmentVector;
 
     // CHECK that Excitation Energy != 0
@@ -233,5 +432,5 @@
     return theResult;
 }
-
+*/
 
 
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationDefaultGEMFactory.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationDefaultGEMFactory.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationDefaultGEMFactory.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4EvaporationDefaultGEMFactory.cc,v 1.1 2009/07/27 10:20:13 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4EvaporationDefaultGEMFactory.cc,v 1.2 2010/04/27 11:43:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -122,4 +122,7 @@
   theChannel->reserve(68);
 
+  theChannel->push_back( new G4PhotonEvaporation() );          // Photon Channel
+  theChannel->push_back( new G4CompetitiveFission() );         // Fission Channel
+
   // JMQ 220709 standard particle evaporation channels (Z<3,A<5)
   theChannel->push_back( new G4NeutronEvaporationChannel() );  // n
@@ -192,7 +195,4 @@
   theChannel->push_back( new G4Mg28GEMChannel() );     // Mg28
 
-  theChannel->push_back( new G4CompetitiveFission() );         // Fission Channel
-  theChannel->push_back( new G4PhotonEvaporation() );          // Photon Channel
-
   return theChannel;
 
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationFactory.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationFactory.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationFactory.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4EvaporationFactory.cc,v 1.4 2006/06/29 20:10:29 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4EvaporationFactory.cc,v 1.5 2010/04/27 11:43:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -32,5 +32,4 @@
 
 #include "G4EvaporationFactory.hh"
-
 
 #include "G4NeutronEvaporationChannel.hh"
@@ -44,27 +43,9 @@
 #include "G4PhotonEvaporation.hh"
 
+G4EvaporationFactory::G4EvaporationFactory()
+{}
 
-const G4EvaporationFactory & 
-G4EvaporationFactory::operator=(const G4EvaporationFactory & )
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationFactory::operator= meant to not be accessable.");
-  return *this;
-}
-
-G4bool 
-G4EvaporationFactory::operator==(const G4EvaporationFactory & ) const
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationFactory::operator== meant to not be accessable.");
-  return false;
-}
-
-G4bool 
-G4EvaporationFactory::operator!=(const G4EvaporationFactory & ) const
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationFactory::operator!= meant to not be accessable.");
-  return true;
-}
-
-
+G4EvaporationFactory::~G4EvaporationFactory()
+{}
 
 std::vector<G4VEvaporationChannel*> * 
@@ -75,4 +56,7 @@
   theChannel->reserve(8);
 
+  theChannel->push_back( new G4PhotonEvaporation() );          // Photon Channel
+  theChannel->push_back( new G4CompetitiveFission() );         // Fission Channel
+
   theChannel->push_back( new G4NeutronEvaporationChannel() );  // n
   theChannel->push_back( new G4ProtonEvaporationChannel() );   // p
@@ -82,6 +66,4 @@
   theChannel->push_back( new G4AlphaEvaporationChannel() );    // Alpha
 
-  theChannel->push_back( new G4CompetitiveFission() );         // Fission Channel
-  theChannel->push_back( new G4PhotonEvaporation() );          // Photon Channel
 
   return theChannel;
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4EvaporationProbability.cc	(revision 1315)
@@ -41,5 +41,6 @@
 #include "G4EvaporationProbability.hh"
 #include "G4PairingCorrection.hh"
-
+#include "G4ParticleTable.hh"
+#include "G4IonTable.hh"
 
 
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4He3EvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4He3EvaporationProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4He3EvaporationProbability.cc	(revision 1315)
@@ -221,5 +221,8 @@
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-  if (cut < 0.) ecut2 = ecut - 2.;
+//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
+//  if (cut < 0.) ecut2 = ecut - 2.;
+  if (cut < 0.) ecut2 = ecut;
   elab = K * FragmentA / ResidualA;
   sig = 0.;
Index: trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4ProtonEvaporationProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4ProtonEvaporationProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/evaporation/src/G4ProtonEvaporationProbability.cc	(revision 1315)
@@ -91,8 +91,9 @@
 
 ///////////////////////////////////////////////////////////////////////////////////
-//J. M. Quesada (Dec 2007-June 2008): New inverse reaction cross sections 
+//J. M. Quesada (Dec 2007-June 2008): New inverse reaction cross sections for protons
 //OPT=0 Dostrovski's parameterization
-//OPT=1,2 Chatterjee's paramaterization 
-//OPT=3,4 Kalbach's parameterization 
+//OPT=1 Chatterjee's parameterization 
+//OPT=2,4 Wellisch's parameterization 
+//OPT=3 Kalbach's parameterization
 // 
 G4double G4ProtonEvaporationProbability::CrossSection(const  G4Fragment & fragment, const  G4double K)
@@ -110,5 +111,4 @@
   FragmentAthrd=std::pow(FragmentA,0.33333);
   U=fragment.GetExcitationEnergy();
-
 
   if (OPTxs==0) {std::ostringstream errOs;
@@ -223,6 +223,5 @@
 //     ** p from  becchetti and greenlees (but modified with sub-barrier
 //     ** correction function and xp2 changed from -449)
-// JMQ (june 2008) : refinement of proton cross section for light systems
-//
+
   G4double landa, landa0, landa1, mu, mu0, mu1,nu, nu0, nu1, nu2;
   G4double p, p0, p1, p2;
@@ -279,5 +278,8 @@
   ecut = (ecut-a) / (p+p);
   ecut2 = ecut;
-  if (cut < 0.) ecut2 = ecut - 2.;
+//JMQ 290310 for avoiding unphysical increase below minimum (at ecut)
+//ecut<0 means that there is no cut with energy axis, i.e. xs is set to 0 bellow minimum
+//  if (cut < 0.) ecut2 = ecut - 2.;
+ if (cut < 0.) ecut2 = ecut;
   elab = K * FragmentA / ResidualA;
   sig = 0.;
@@ -286,18 +288,8 @@
     signor2 = (ec-elab-c) / w;
     signor2 = 1. + std::exp(signor2);
-    sig = sig / signor2;
-    // signor2 is empirical global corr'n at low elab for protons in PRECO, not enough for light targets
-    //  refinement for proton cross section
-    if (ResidualZ<=26)
-      sig = sig*std::exp(-(a2*ResidualZ + b2)*(elab-(afit*ResidualZ+bfit)*ec)*(elab-(afit*ResidualZ+bfit)*ec));      
-                       }              //end for E<Ec
+    sig = sig / signor2;     
+                       }       //end for E<=Ec
   else            {           //start for  E>Ec
     sig = (landa*elab+mu+nu/elab) * signor;
-
-    //  refinement for proton cross section
-    if ( ResidualZ<=26 && elab <=(afit*ResidualZ+bfit)*ec) 
-           sig = sig*std::exp(-(a2*ResidualZ + b2)*(elab-(afit*ResidualZ+bfit)*ec)*(elab-(afit*ResidualZ+bfit)*ec));
-                                                                               
-//
     geom = 0.;
 
